<?php
/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* Syndeo CMS Software Version: 2.6.00 
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@gmail.com)
* original script comes from: http://acalproj.sourceforge.net/ 
* Calendar module : 
* calendar.php: last changed 07/03/2008 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
*/
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}
load_language($cmsdir . '/', 'sn_calendar'); //load language file
$table_events = $dbprefix . "m_calendar_events";
$table_calendars = $dbprefix . "m_calendars";

$query = "SELECT id, options, title FROM $table_calendars WHERE name = '".$pagetitle."' LIMIT 1";
$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br/>Query : "' . $query . '".',E_USER_WARNING); 
$num_rows = mysqli_num_rows($result);

if ($num_rows == 0)		//we have no calendar with this pagename.
{
	print "<span class=\"sas_module_error\">" . $sas_lang['calendar_page_error'] . "</span>";
}
else
{
	$cal_id = mysqli_result($result, 0, 0);
	$calendar_options = mysqli_result($result, 0, 1);
	$cal_title = mysqli_result($result, 0, 2);
	unset ($query);
	unset ($result);

	$calendar_options = explode(",", $calendar_options);
	//print_r($calendar_options);
	$table_color = $calendar_options[0];
	$table_bg_act = $calendar_options[1];
	$table_bg = $calendar_options[2];
	
	$week_day = $calendar_options[3];
	$week_day_bg_act = $calendar_options[4];
	$week_day_bg = $calendar_options[5];
	
	$event_day = $calendar_options[6];
	$event_bg_act = $calendar_options[7];
	$event_day_bg = $calendar_options[8];
	
	$table_bgcolor = $calendar_options[9];
	
	$day_today = $calendar_options[10];
	$day_today_bg_act = $calendar_options[11];
	$day_today_bg = $calendar_options[12];

	$day_color = $calendar_options[13];
	$day_bg_act = $calendar_options[14];
	$day_bg = $calendar_options[15];
	
	$arrow_left = $calendar_options[16];
	$arrow_right = $calendar_options[17];
	
	$popup_bgcolor = $calendar_options[18];
	$popup_font_color = $calendar_options[19];
	$first_day_of_week = $calendar_options[20];
}

// Get the year
if ($_GET['year'] != '') 
{
	$year = intval($_GET['year']);
}
else 
{
	$year = date('Y');
}

// Get the month
if ($_GET['month'] != '') 
{
	$month = intval($_GET['month']);
}
else 
{
	$month = date('n');
}

// Get some dates and time
$mkdate = mktime(0,0,0, $month, 1, $year);
$weekday = date('w', $mkdate);
$pweekday = date('w', $mkdate);
$firstday = date('w', $mkdate);
$day = 1;
$days = date('t', $mkdate);
$current_year = date('Y');

//read the events for the choosen month
$query = "SELECT description FROM $table_events WHERE month = '$month' AND year = '$year' AND calendar = '".$cal_id."'";
$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br/>Query : "' . $query . '".',E_USER_WARNING); 
	
	if (mysqli_num_rows($result) > 0)
	{
		$details = mysqli_result($result, 0);
	}
	else
	{
		$details = "";
	}

$arr_details = explode("\n", $details);
$event_titles = array ();	//array for the event titles
$popups = array ();			//array for the popup texts	

$count = 1 ;

for ($i = 0; $i < count($arr_details); $i++)
{
	$entry = explode("_", $arr_details[$i]);
	
	//split the entry in a title and a popup part
	if (strpos($entry[1], ',') == FALSE)
	{
		$title = $entry[1] ; //if no comma , use whole entry
		$popup = "";
	}
	else
	{
		$title = substr($entry[1], 0, strpos($entry[1], ','));
		$popup = substr($entry[1], strpos($entry[1], ',') + 1);
	}

	if ((strpos($entry[0], '-') == 1) OR (strpos($entry[0], '-') == 2)) //do we have string like 11-15_ then we have multiple days
	{
		$first = substr($entry[0], 0, strpos($entry[0], '-'));
		$last = substr($entry[0], strpos($entry[0], '-') + 1);
		$k = $first ; //starting point
		for ($k = $first; $k <= $last; $k++) 	//loop through the multiple days
		{
			if ((isset($event_titles[$k])) AND (array_key_exists($count, $event_titles[$k]))) //lets see if we have this day already in our array
			{
				$count++ ; //event count
			}
			else
			{
				$count = 1; //reset to 1
			}
			$event_titles[$k][$count] = $title ;
			$popups[$k][$count] = $popup ;		
		}
	}
	else //single day
	{	
		if ((isset($event_titles[$entry[0]])) AND (array_key_exists($count, $event_titles[$entry[0]]))) //lets see if we have this day already in our array
		{
			$count++ ;
		}
		else
		{
			$count = 1;
		}
		$event_titles[$entry[0]][$count] = $title ;
		$popups[$entry[0]][$count] = $popup ;	
		
	}
}
?>
  
<script language="JavaScript" src="starnet/modules/sn_calendar/overlib.js"></script>
<script type="text/javascript">
function NewWindow (link) 
{
var win_left = (screen.width - 500) / 2;
var win_top = (screen.height - 400) / 2;
  window1 = window.open(link, "Add_event", "width=500,height=400,resizable=yes,scrollbars=no");
  window1.moveTo(win_left,win_top);
  window1.focus();
}
</script>
<?php
print "<style type=\"text/css\">
table.calendar {
 margin-right: auto;
 margin-left: auto;
 width: 98%;
 border: 1px solid $table_bgcolor;
}

table.header {
 width: 98%;
 margin-right: auto;
 margin-left: auto;
 border-top: 1px solid $table_bgcolor;
 border-right: 1px solid $table_bgcolor;
 border-left: 1px solid $table_bgcolor;";
 
if($table_bg_act == 1)
{ 
	print "\nbackground-image: url(\"$table_bg\");";
}
else
{ 
	print "\nbackground-color: $table_color;";
}
print "\n}
.title {
 text-align: center;
 border-top: 1px solid $table_bgcolor;
 border-right: 0px;
 border-left: 0px;
 width: 71%;
}
.sas_module_lbl2 {
 text-align: center;
 width: 14%;
 border: 1px solid $table_bgcolor;";
 
if($week_day_bg_act == 1)
{ 
	print "\nbackground-image: url(\"$week_day_bg\");";
}
else
{ 
	print "\nbackground-color: $week_day;";
}
print "\n}

.day {
 border: 1px solid $table_bgcolor;
 width: 14%;
 height: 75px;
 vertical-align: top;";
 
if($day_bg_act == 1)
{ 
	print "\nbackground-image: url(\"$day_bg\");";
}
else
{ 
	print "\nbackground-color: $day_color;";
}
print "\n}
#now {
 border: 1px solid $table_bgcolor;
 width: $day_width;
 height: 75px;
 vertical-align: top;";
 
if($day_today_bg_act == 1)
{ 
	print "\nbackground-image: url(\"$day_today_bg\");";
}
else
{ 
	print "\nbackground-color: $day_today;";
}
print "\n}
.sas_module_text {
 border: 1px outset;
 margin-bottom: 3px;";
 
if($event_bg_act == 1)
{ 
	print "\nbackground-image: url(\"$event_day_bg\");";
}
else
{ 
	print "\nbackground-color: $event_day;";
}
print "\n}

.event a:hover {";
 
if($event_bg_act == 1)
{ 
	print "\nbackground-image: url(\"$event_day_bg\");";
}
else
{ 
	print "\nbackground-color: $event_day;";
}
print "\n}
img {
 border: 0px none;
}

.jump {
 text-align: center;
 border-bottom: 1px solid $table_bgcolor;
}

.back {
 text-align: left;
 border-top: 1px solid $table_bgcolor;
 border-right: 0px;
 border-left: 1px solid $table_bgcolor;
}

.next {
 text-align: right;
 border-top: 1px solid $table_bgcolor;
 border-right: 1px solid $table_bgcolor;
 border-left: 0px;
}
.fback {
 text-align: left;
 border-bottom: 1px solid $table_bgcolor;
 border-right: 0px;
 border-left: 1px solid $table_bgcolor;
 vertical-align: top;
}

.fnext {
 text-align: right;
 border-bottom: 1px solid $table_bgcolor;
 border-right: 1px solid $table_bgcolor;
 border-left: 0px;
 vertical-align: top;
}
.footer {
 width: 98%;
 margin-right: auto;
 margin-left: auto;
 border-top: 0px;
 border-right: 1px solid $table_bgcolor;
 border-left: 1px solid $table_bgcolor;
 border-bottom: 1px solid $table_bgcolor;";
 
if($table_bg_act == 1)
{ 
	print "\nbackground-image: url(\"$table_bg\");";
}
else
{ 
	print "\nbackground-color: $table_color;";
}
print "\n}
</style>";
?>
 </head>
 <body>
  <table class="header" cellpadding="0" cellspacing="0">
   <tbody>
    <tr>
     <td class="back">
<?php
      if ($month == 1) 
	  {
      	$backy = $year;
      	echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=" . --$backy . "&month=12\">";
      }
      else 
	  {
      	$bmonth = $month;
      	$bmonth--;
      	$bmonth = sprintf('%02d' , $bmonth);
		echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=$year&amp;month=$bmonth\">";
      }
?>
<img src="<?php echo $arrow_left; ?>" title="<?php echo $sas_lang['calendar_previous']; ?>" alt="<?php echo $sas_lang['calendar_previous']; ?>" /></a></td>
     <td class="title">
<?php 
echo "<span class=\"sas_module_title\">". $sas_lang[month.$month] . " " . $year . "</span>" ;

if ($cal_title != "")
{
	print "<br /><span class=\"sas_module_subtitle\">" . $cal_title . "</span>";
}
?>
     </td>
     <td class="next">
      <?php
      if ($month == '12') 
	  {
      	$nexty = $year;
      	echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=" . ++$nexty . "&month=1\">";
      }
      else 
	  {
      	$nmonth = $month;
      	$nmonth++;
      	$nmonth = sprintf('%02d' , $nmonth);
      	echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=$year&amp;month=$nmonth\">";
      }
      ?>
      <img src="<?php echo $arrow_right; ?>" title="<?php echo $sas_lang['calendar_next']; ?>" alt="<?php echo $sas_lang['calendar_next']; ?>" /></a>
     </td>
    </tr>
   </tbody>
  </table>
  
<?php  
print   "<table class=\"calendar\" cellpadding=\"0\" cellspacing=\"0\">
   <tbody>
    <tr>";
if($first_day_of_week == 1)
{	 
	print "<td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_sunday']."</td>";
}
print "<td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_monday']."</td>";
print "<td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_tuesday']."</td>
     <td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_wednesday']."</td>
     <td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_thursday']."</td>
     <td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_friday']."</td>
     <td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_saturday']."</td>";
if($first_day_of_week == 0)
{	 
	print "<td class=\"sas_module_lbl2\">".$sas_lang['calendar_module_sunday']."</td>";
}

print "</tr>
    <tr>";

$weeks = 1;

//for sunday as last day of the week 
if(($weekday == 0) AND ($first_day_of_week == 0))
{
	$weekday = 7 ;
}
if($first_day_of_week == 0)
{
	$weekday = $weekday - 1; //for sunday as last day of the week 
}
$weeks = 1;

$loopCount = 1;
while ($loopCount <= $weekday) 
{
	echo '<td class="day">&nbsp;</td>';
	$loopCount++;
}

//Now generate all the days

$weekday++;

while ($day <= $days) 
{
	
	//Check if this is the current day
	if (date("d") == $day && date("n") == $month && date("Y") == $year) 
	{
    	print "\r<td id=\"now\">";
    }
	else
	{
		print "\r<td class=\"day\">";
	}

	$lday = sprintf('%02d' , $day);

	print "<span class=\"sas_module_lbl1\">".$day."</span>" ;
	
	if(trim($event_titles[$day][1]) != "") //check the first entry
	{	
		for ($i = 1; $i <= count($event_titles[$day]); $i++)
		{
			print "<div class=\"sas_module_text\">";
			
			if(trim($popups[$day][$i]) != "")
			{
				$popup_text = str_replace("'","&rsquo;",$popups[$day][$i]); //replace single quote with &rsquo;
				$order   = array("\r\n", "\n", "\r");
				$popup_text = str_replace($order,"",$popup_text);
				print "<a href=\"javascript:void(0);\" onmouseover=\"return overlib('" . $popup_text. "', FGCOLOR, '$popup_bgcolor', TEXTCOLOR, '$popup_font_color')\" onmouseout=\"return nd();\">";
			}	
			print $event_titles[$day][$i] . "</a></span>";
			print "</div>";
		}
	}
	echo "\r</td>";
	
	//If last day of week then start new week
	if ($weekday == 7) 
	{
		echo '</tr><tr>';
		$weekday = 0;
		$weeks++;
	}
	
	$day++;
	$sieve++;
	$weekday++;
}

$dim = $weeks * 7;
if($first_day_of_week == 0)
{
	$lastdays = $dim - ($days + $pweekday-1);
}
else
{
	$lastdays = $dim - ($days + $pweekday);
}
//when lastdays 7 we do not want an empty row, so substract 7 
if($lastdays > 6 )
{
	$lastdays = $lastdays - 7;
}
$lc = 1;
while ($lc <= $lastdays) 
{
	echo '<td class="day">&nbsp;</td>';
	$lc++;
}
?>

</tr>
    
   </tbody>
  </table>
  
  <table class="footer" cellpadding="0" cellspacing="0">
   <tbody>
    <tr>
     <td class="fback">
<?php
      if ($month == 1) 
	  {
      	$backy = $year;
      	echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=" . --$backy . "&month=12\">";
      }
      else 
	  {
      	$bmonth = $month;
      	$bmonth--;
      	$bmonth = sprintf('%02d' , $bmonth);
      	echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=$year&amp;month=$bmonth\">";
      }
?>
     <img src="<?php echo $arrow_left; ?>" title="<?php echo $sas_lang['calendar_previous']; ?>" alt="<?php echo $sas_lang['calendar_previous']; ?>" /></a></td>
     <td class="jump">
     <form method="get" action="index.php">
	 <input type="hidden" name="section" value="<?php echo $section; ?>">
	 <input type="hidden" name="page" value="<?php echo $page; ?>">
     <select name="year" class="sas_module_link">
<?php
       for ($i = -1; $i <= 3; $i++) 
		{
			$years = $current_year + $i;
			
			print "<option value=\"$years\"";
			
			if (date('Y') == "$years") 
			{
			print " selected=\"selected\"";
			}
			print ">$years</option>";
		}
?>
     </select>
     <select name="month" class="sas_module_link">
      <option value="1"<?php
      if (date('n') == 1) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month1']; ?></option>
      <option value="2"<?php
      if (date('n') == 2) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month2']; ?></option>
      <option value="3"<?php
      if (date('n') == 3) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month3']; ?></option>
      <option value="4"<?php
      if (date('n') == 4) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month4']; ?></option>
      <option value="5"<?php
      if (date('n') == 5) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month5']; ?></option>
      <option value="6"<?php
      if (date('n') == 6) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month6']; ?></option>
      <option value="7"<?php
      if (date('n') == 7) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month7']; ?></option>
      <option value="8"<?php
      if (date('n') == 8) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month8']; ?></option>
      <option value="9"<?php
      if (date('n') == 9) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month9']; ?></option>
      <option value="10"<?php
      if (date('n') == 10) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month10']; ?></option>
      <option value="11"<?php
      if (date('n') == 11) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month11']; ?></option>
      <option value="12"<?php
      if (date('n') == 12) {
      	echo " selected=\"selected\"";
      }
      ?>><?php echo $sas_lang['month12']; ?></option>
     </select><input type="submit" value="<?php echo $sas_lang['calendar_go']; ?>" />
     </form>
     </td>
     <td class="fnext">
<?php
      if ($month == '12') 
	  {
      	$nexty = $year;
      	echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=" . ++$nexty . "&month=1\">";
      }
      else 
	  {
      	$nmonth = $month;
      	$nmonth++;
      	$nmonth = sprintf('%02d' , $nmonth);
      	echo "<a href=\"index.php?section=$section&amp;page=$page&amp;year=$year&amp;month=$nmonth\">";
      }
?>
      <img src="<?php echo $arrow_right; ?>" title="<?php echo $sas_lang['calendar_next']; ?>" alt="<?php echo $sas_lang['calendar_next']; ?>" /></a>
     </td>
    </tr>
   </tbody>
  </table>